/*
* Beispiel Nachrichtenkommunikation
* Client: Sendet Nachricht an Server (geht davon aus,
12
* dass Zugriff auf Warteschlange eingerichtet ist)
* Wartet auf Antwort vom Server
*/

#include "MSG_BUFFER.h"


int main(){
	MSGBUF buf;
	int Zahl;
	char Buffer;
	int qid;

	qid = msgget(KEY_ALME, 0600); // Warteschlangen-ID

	//Buffer leer räumen, damit kein Datenmüll übertragen wird
	memset(buf.msg,0,SIZE);

	// Hole PID, damit der Server weiß wo die Nachricht herkommt
	//buf.pid = getpid();

	std::cout << "Client Queue ID = " << qid << "\n";
	std::cout << " 0 = ALME_RESET.confirm\n";
	std::cout << " 4 = ALME_WMIB_SET.confirm\n";
	std::cout << " 8 = ALME_WMIB_GET.confirm\n";
	std::cout << "12 = ALME_DMIB_SET.confirm\n";
	std::cout << "16 = ALME_DMIB_GET.confirm\n";
	std::cout << "20 = ALME_WSS_CREATE.confirm\n";
	std::cout << "24 = ALME_WSS_DESTROY.confirm\n";
	std::cout << "25 = ALME_WSS_DESTROY.indication\n";
	std::cout << "28 = ALME_WSS_ASSOCIATE.confirm\n";
	std::cout << "32 = ALME_WSS_DISASSOCIATE.confirm\n";
	std::cout << "36 = ALME_SCAN.confirm\n";
	std::cout << "41 = ALME_SCAN_PLCP_HEADER_RECEIVED.indication\n";
	std::cout << "44 = ALME_HIBERNATE.confirm\n";
	std::cout << "45 = ALME_HIBERNATE.confirm\n";
	std::cout << "48 = ALME_BEACON_START.confirm\n";
	std::cout << "52 = ALME_BEACON_STOP.confirm\n";
	std::cout << "56 = ALME_BEACON_CHANGE_CHANNEL.confirm\n";
	std::cout << "61 = ALME_BEACON.indication\n";
	std::cout << "\nBitte Eingabe machen : ";

	while (1) {

		//Gebe Nachricht über Tastatur ein, bei Ctrl-D ist Programmende
		std::cin >> Zahl;

		//Zahl in Char (ASCII) umwandeln
		Buffer=(char)Zahl;

		//1. Zeichen an erstes Feld im ARRAY übertragen
		buf.msg[0]=Buffer;

		//Buffer senden
		buf.mtyp = 1;
		printf("Buffer: %c\n",buf.msg[0]);
		msgsnd(qid, &buf, sizeof (MSGBUF), 0);

		// Strg+D eingegeben
		if (feof(stdin)){break;}
	}
}

