/*!
 *  @file WLP.h
 *
 *  @author Daniel Brockmann
 *  @date 13.05.2010
 *
 *  @version 0.1
 *
 *  @brief basic defines, main libraries, prototypes for WLP
 *
*/

//! standard libraries
#include <iostream>
#include <string>

//! necessary for childprocess FOLK()
#include <sys/types.h>
#include <unistd.h>

//! necessary for WAITPID()
#include <sys/wait.h>

//! general functions
void BLOCK_RESET(int FKT, char *blk_XLME);
void BLOCK_SET(int FKT, char *blk_XLME);
int BLOCK_CHECK(int FKT, char *blk_XLME);

//! child function prototypes
void WLME_CHILD(char WLME_MSG[], pid_t *pid_WLME, char *blk_WLME, int (*WLME_PRIMITIV)(char MSG[]));

//! code convert function prototypes
int WLME_CONVERT(int WLME_CODE);

//! read function prototypes
void WLME_READ(int WLME_FKT, pid_t *pid_WLME, char *blk_WLME);

//! \TODO complete
void BLOCK_SET(int FKT, char *blk_XLME){
	int FIELD, BIT;

	FIELD=FKT/8;
	BIT=FKT%8;

	printf ("BLOCK_SET: blk_XLME %x \n", blk_XLME[FIELD]);

	switch (BIT){
		case 0: blk_XLME[FIELD]=blk_XLME[FIELD]|0x01; break;
		case 1: blk_XLME[FIELD]=blk_XLME[FIELD]|0x02; break;
		case 2: blk_XLME[FIELD]=blk_XLME[FIELD]|0x04; break;
		case 3: blk_XLME[FIELD]=blk_XLME[FIELD]|0x08; break;
		case 4: blk_XLME[FIELD]=blk_XLME[FIELD]|0x10; break;
		case 5: blk_XLME[FIELD]=blk_XLME[FIELD]|0x20; break;
		case 6: blk_XLME[FIELD]=blk_XLME[FIELD]|0x40; break;
		case 7: blk_XLME[FIELD]=blk_XLME[FIELD]|0x80; break;
	}

	printf ("BLOCK_SET: blk_XLME %x \n", blk_XLME[FIELD]);
}

//! \TODO complete
void BLOCK_RESET(int FKT, char *blk_XLME){
	int FIELD, BIT;

	FIELD=FKT/8;
	BIT=FKT%8;

	printf ("BLOCK_RESET: blk_XLME %x \n", blk_XLME[FIELD]);

	switch (BIT){
		case 0: blk_XLME[FIELD]=blk_XLME[FIELD]&0xFE; break;
		case 1: blk_XLME[FIELD]=blk_XLME[FIELD]&0xFD; break;
		case 2: blk_XLME[FIELD]=blk_XLME[FIELD]&0xFB; break;
		case 3: blk_XLME[FIELD]=blk_XLME[FIELD]&0xF7; break;
		case 4: blk_XLME[FIELD]=blk_XLME[FIELD]&0xEF; break;
		case 5: blk_XLME[FIELD]=blk_XLME[FIELD]&0xDF; break;
		case 6: blk_XLME[FIELD]=blk_XLME[FIELD]&0xBF; break;
		case 7: blk_XLME[FIELD]=blk_XLME[FIELD]&0x7F; break;
	}
	printf ("BLOCK_RESET: blk_XLME %x \n", blk_XLME[FIELD]);
}

//! \TODO complete
int BLOCK_CHECK(int FKT, char *blk_XLME){
	int FIELD, BIT;

	FIELD=FKT/8;
	BIT=FKT%8;

	if (((blk_XLME[FIELD]>>BIT)&0x01)==1){ return 1;}
	else if (((blk_XLME[FIELD]>>BIT)&0x01)==0) { return 0;}

}
